/*
 *  OpenDuke
 *  Copyright (C) 1999  Rusty Wagner
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 */


//---------------------------------------------------------------------------
#ifndef DSoundEngineH
#define DSoundEngineH

#include <mmsystem.h>
#include <dsound.h>
#include "Sound.h"

class DirectSoundEngine: public SoundEngine
{
protected:
    struct
    {
        int type;
        LPDIRECTSOUNDBUFFER buf;
        int pri;
        unsigned long start;
    } ch[SOUND_CHANNELS];
    int init;
    int soundMute;
    LPDIRECTSOUND lpDS;
public:
    DirectSoundEngine(HWND hWnd);
    ~DirectSoundEngine();
    int Initialized();
    void SetChannelType(int c,int t);
    int PlaySound(Sound *snd,int t,int pri,int loop);
    void StopSound(int c);
    void SoundMute(int mute);
};

//---------------------------------------------------------------------------
#endif
