/*
 *  OpenDuke
 *  Copyright (C) 1999  Rusty Wagner
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 */


//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#if 0
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <MPlayer.hpp>
#endif
#include "GroupFile.h"
#include "RTSFile.h"
#include "art.h"
#include "map.h"
//#include "DirectInput.h"
#include "Sound.h"
#include "anm.h"
#include "Render.h"
#include "ConEngine.h"

#define TEXTURE_MENU_TEXTHEADER 2457
#define TEXTURE_STATUS_BAR 2462
#define TEXTURE_DIGITAL_NUMBERS 2472
#define TEXTURE_TITLE 2493
#define TEXTURE_TITLE_DUKE_NUKEM 2497
#define TEXTURE_TITLE_3D 2498
#define TEXTURE_MENU_HEADER 2499
#define TEXTURE_MENU_SELECT 2813
#define TEXTURE_STD_FONT 2822
#define TEXTURE_LARGE_FONT 2930
#define TEXTURE_SMALL_FONT 3010

#define MAX_MENU_LEVELS 4

#define MENUTYPE_NORMAL 0
#define MENUTYPE_OPTIONS 1

#define MENUITEM_NORMAL 0
#define MENUITEM_DISABLED 1
#define MENUITEM_YESNO 2
#define MENUITEM_ONOFF 3
#define MENUITEM_MODELIST 4
#define MENUITEM_DEPTHLIST 5
#define MENUITEM_DRIVERLIST 6
#define MENUITEM_NAME 7
#define MENUITEM_PLAYERS 8
#define MENUITEM_PORT 9

struct Menu
{
    char *item;
    void (* func)(void);
    int y;
    int type;
    int value;
};

//---------------------------------------------------------------------------
#if 0
class TForm1 : public TForm
{
__published:	// IDE-managed Components
    TTimer *Timer1;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall FormDeactivate(TObject *Sender);
    void __fastcall FormKeyPress(TObject *Sender, char &Key);
    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall FormClick(TObject *Sender);
#endif
class TForm1
{
private:	// User declarations
    void ExecuteConsoleCommand(char *action,char *param);
    void DrawCenteredDigitalNumber(int x,int y,int num);
    void DrawSmallText(int x,int y,char *text,unsigned long color);
    void DrawCenteredLargeText(int x,int y,char *text,unsigned long color);
    void DrawLargeText(int x,int y,char *text,unsigned long color);
    void DrawMenu(void);
    void IntroAnimState(void);
    void PlayAnimState(void);
    void DukeLogoState(void);
    void MapLoadState(void);
    void MenuState(void);
    void GameState(void);
    void MenuKeyHandler(int Key);
    void GameKeyHandler(int Key);
    void DynamicResChange(void);
    bool minimized;
    GroupFile *group;
    RTSFile *rts;
    ConEngine *con;
    Art art;
    int titlePalNum;
    // These must have been inherited from TForm - DDOI
    int ClientWidth, ClientHeight;
    Map *curMap;
    //CDirectInput *di;
    //int useDirectInput;
    SoundEngine *sound;
    Sound *rtsSound[10];
    Sound *secRtsSound[10];
    ANMFile *curAnim,*introAnim;
    Sound *animSound1;
    Sound *animSound2;
    Sound *menuMoveSound;
    Sound *menuSelectSound;
    Sound *menuExitSound;
    Sound *skillSound[4];
    int frames,fps;
    int showfps;
    int showstats;
    int markcursect;
    int vid_windowed,vid_width,vid_height,vid_depth;
    int animStarted;
    int lastTime;
    int menuSelected,menuAnimFrame,prevMenuSelected[MAX_MENU_LEVELS];
    struct Menu *menu,*prevMenu[MAX_MENU_LEVELS];
    struct Menu *menuItem;
    int prevCount;
    int episode;
    char mapLoadName[256];
    char directory[256];
    enum {INTRO_ANIM,DUKE_LOGO,GAME,PLAY_ANIM,
        MAP_LOAD,MENU} state,oldState;
    enum {INTRO_ANIM_PLAY,INTRO_ANIM_FADE_OUT,
        DUKE_LOGO_FADE_IN,DUKE_LOGO_START,
        DUKE_LOGO_DUKENUKEM,DUKE_LOGO_3D,
        DUKE_LOGO_END,DUKE_LOGO_FADE_OUT,
        GAME_PLAYING,GAME_PAUSED,MENU_SELECT,
        MENU_WAIT_FOR_SOUND} subState;
public:		// User declarations
#if 0
    __fastcall TForm1(TComponent* Owner);
    void __fastcall OnIdle(TObject *,bool& done);
    void __fastcall MCIWindowProc(TMessage&);
    void __fastcall FormMinimize(TObject *);
    void __fastcall FormRestore(TObject *);
#endif
    // Start of Replacements - DDOI ------------------
    TForm1(void);
    void OnIdle(bool& done);
    void MCIWindowProc(void);
    void FormMinimize(void);
    void FormRestore(void);
    // These are going in as public instead, since there's no C++ Builder
    //    interfact - DDOI
    void FormCreate(void);
    void FormActivate(void);
    void FormDeactivate(void);
    void FormKeyPress(WORD &Key);
    void Timer1Timer(void);
    void FormKeyDown(WORD &Key);        //rcg11032000 Linuxized.
    void FormClose(void);
    void FormClick(void);
    // end - DDOI ------------------------------------
    void YesNoItem(void);
    void NewGame(void);
    void Options(void);
    void SaveGame(void);
    void LoadGame(void);
    void Help(void);
    void Quit(void);
    void QuitToTitle(void);
    void Episode1(void);
    void Episode2(void);
    void Episode3(void);
    void Skill1(void);
    void Skill2(void);
    void Skill3(void);
    void Skill4(void);
    void WindowedOption(void);
    void ResolutionOption(void);
    void BitDepthOption(void);
    void DriverOption(void);
    void SoundOption(void);
    void MusicOption(void);
    void Multiplayer(void);
    void FindServers(void);
    void ConnectToServer(void);
    void StartNewServer(void);
    void MapsToCycle(void);
    void ServerGameOptions(void);
    void CreateServer(void);
    void JoinServer(void);
};
//---------------------------------------------------------------------------
#if 0
extern PACKAGE TForm1 *Form1;
#endif
extern TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
